%global namedreltag .Final-redhat-1
%global namedversion %{version}%{?namedreltag}
%global reltag .Final_redhat_1

%bcond_without mead
%define _jarsign_opts --copy=%{_javadir} --unsign=%{_javadir}

%define maven_version 1.1.1.Final-redhat-1

Name:             jboss-dmr
Version:          1.1.1
Release:          6%{reltag}%{?dist}
Summary:          JBoss DMR
Group:            Development/Libraries

%if %with mead
Source100: org.jboss-jboss-dmr-1.1.1.Final-redhat-1-sources.zip
Source101: org.jboss-jboss-dmr-1.1.1.Final-redhat-1-patches.zip
Source102: jboss-dmr-1.1.1.Final-redhat-1.pom
Source103: jboss-dmr-1.1.1.Final-redhat-1-javadoc.jar
Source104: jboss-dmr-1.1.1.Final-redhat-1.jar
Source105: jboss-dmr-1.1.1.Final-redhat-1-sources.jar
%endif

License:          LGPLv2+
URL:              https://github.com/jbossas/jboss-dmr

%if %without mead
# git clone git://github.com/jbossas/jboss-dmr.git
# cd jboss-dmr/ && git archive --format=tar --prefix=jboss-dmr-1.1.1.Final/ 1.1.1.Final | xz > jboss-dmr-1.1.1.Final.tar.xz
Source0:          %{name}-%{namedversion}.tar.xz
Patch0:           %{name}-%{namedversion}-pom.patch
%endif

BuildArch:        noarch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-buildroot

BuildRequires:    jpackage-utils
%if %without mead
BuildRequires:    maven
BuildRequires:    maven-compiler-plugin
BuildRequires:    maven-install-plugin
BuildRequires:    maven-jar-plugin
BuildRequires:    maven-javadoc-plugin
BuildRequires:    maven-release-plugin
BuildRequires:    maven-resources-plugin
BuildRequires:    maven-surefire-plugin
BuildRequires:    junit4
BuildRequires:    maven-surefire-provider-junit4
BuildRequires:    jboss-parent
BuildRequires:    jboss-logmanager
BuildRequires:    cookcc
BuildRequires:    apiviz
Requires:         jboss-logmanager
Requires:         jpackage-utils
%endif

%description
This package contains the Dynamic Model Representation.

%package javadoc
Summary:          Javadocs for %{name}
Group:            Documentation

Requires:         jpackage-utils

%description javadoc
This package contains the API documentation for %{name}.

%prep
%if %without mead
%setup -q -n %{name}-%{namedversion}
%patch0 -p1

mv src/placeholder/java/org/jboss/dmr/*.java src/main/java/org/jboss/dmr/
%endif

%build
%if %without mead
# Skipped tests because of one failure - testFromJSONString
# Tests run: 201, Failures: 1, Errors: 1, Skipped: 0 
mvn-rpmbuild -Dmaven.test.skip=true install javadoc:aggregate
%endif

%install
# JAR
install -d -m 755 $RPM_BUILD_ROOT%{_javadir}
%if %without mead
cp -p target/%{name}-%{namedversion}.jar $RPM_BUILD_ROOT%{_javadir}
%else
cp -p %{_sourcedir}/%{name}-%{namedversion}.jar $RPM_BUILD_ROOT%{_javadir}
cp -p %{_sourcedir}/%{name}-%{namedversion}-sources.jar %{buildroot}%{_javadir}
%endif

(cd %{buildroot}%{_javadir} && for jar in *-%{namedversion}*; do %{__ln_s} ${jar} `/bin/echo ${jar} | %{__sed} -e "s|-%{namedversion}||g"`; done)

%if %without mead
# APIDOCS
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}
cp -rp target/site/apidocs/* $RPM_BUILD_ROOT%{_javadocdir}
%else
# javadoc
%{__mkdir_p} %{buildroot}%{_javadocdir}/%{name}-%{namedversion}
%{__unzip} -qq %{_sourcedir}/%{name}-%{namedversion}-javadoc.jar -d %{buildroot}%{_javadocdir}/%{name}-%{namedversion}
%{__rm} -r %{buildroot}%{_javadocdir}/%{name}-%{namedversion}/META-INF
%{__ln_s} %{name}-%{namedversion} %{buildroot}%{_javadocdir}/%{name}
%endif

# POM
install -d -m 755 $RPM_BUILD_ROOT%{_mavenpomdir}
%if %without mead
install -pm 644 pom.xml $RPM_BUILD_ROOT%{_mavenpomdir}/JPP-%{name}.pom
%else
install -pm 644 %{_sourcedir}/%{name}-%{namedversion}.pom \
        $RPM_BUILD_ROOT%{_mavenpomdir}/JPP-%{name}.pom
%endif

# DEPMAP
%add_to_maven_depmap org.jboss %{name} %{namedversion} JPP %{name}

%post
%update_maven_depmap

%postun
%update_maven_depmap

%clean
%{__rm} -rf %{buildroot}

%files
%{_mavenpomdir}/*
%{_mavendepmapfragdir}/*
%{_javadir}*/*

%files javadoc
%{_javadocdir}/%{name}-%{namedversion}
%{_javadocdir}/%{name}

%changelog
* Wed Apr 18 2012 Hui Wang <huwang@redhat.com> 1.1.1-6.Final_redhat_1
- Change jboss-parent'version to 8-redhat-1
- Add javadoc subpackage

* Wed Mar 14 2012 Hui Wang <huwang@redhat.com> 1.1.1-5.Final_redhat_1.1
- New wrapper
- Remove extra %%{name} from installing path
- Fix release tag

* Tue Feb 28 2012 Fernando Nasser <fnasser@redhat.com> 1.1.1-4
- Populate javadir-signed

* Mon Jan 30 2012 Fernando Nasser <fnasser@redhat.com> 1.1.1-3
- Cookcc not required at run-time

* Mon Jan 09 2012 Fernando Nasser <fnasser@redhat.com> 1.1.1-2
- Wrap MEAD build for EAP 6

* Wed Dec 07 2011 Marek Goldmann <mgoldman@redhat.com> 1.1.1-1
- Upstream release 1.1.1.Final

* Sun Oct 02 2011 Marek Goldmann <mgoldman@redhat.com> 1.0.0-2
- Spec file cleanup

* Mon Aug 01 2011 Marek Goldmann <mgoldman@redhat.com> 1.0.0-1
- Initial packaging

